<template>
  <lazy-theme-desktop-china-components-no-game
    v-if="!gameEntrySelected.length"
  />
  <!-- eslint-disable max-len -->
  <div
    v-else
    class="w-full min-w-[1230px] relative bg-[#f0f6ff] h-[960px] pt-[200px]"
    :style="`--activeBtnBackground: ${activeBtnBackground};`"
  >
    <div class="w-[1200px] mx-auto flex items-center">
      <div class="h-[650px] min-w-[700px] relative">
        <div
          v-if="activeTab !== 'cockfight'"
          class="relative z-0 flex justify-start w-full page-banner-logo"
        >
          <transition appear mode="out-in">
            <img
              v-if="!isDisappear"
              id="pageBannerImg"
              :src="
                handleImportImage(themeName, `${folderName}/${bannerImg}.png`)
              "
            />
          </transition>
        </div>
        <div class="sport_ads sport-ads-animation">
          <Transition appear mode="out-in">
            <img
              v-if="!isDisappear"
              class="max-w-[650px]"
              :src="
                handleImportImage(themeName, `${folderName}/${imgName}.png`)
              "
            />
          </Transition>
          <img
            v-if="activeTab === 'cockfight' && !isDisappear"
            id="sport1_coin1"
            class="w-[304px] h-[596px] top-0 -left-[22px] absolute z-[1] pyramid_animation"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/desktop/images/cockfight/cockfightingcoinleft1.png'
              )
            "
            alt=""
          />
          <img
            v-if="activeTab === 'cockfight' && !isDisappear"
            id="sport1_coin2"
            class="w-[338px] h-[663px] top-[10px] right-0 absolute z-[1] pyramid_animation"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/desktop/images/cockfight/cockfightingcoinright1.png'
              )
            "
            alt=""
          />
        </div>
        <div v-if="activeTab === 'virtualsports'">
          <img
            v-if="!isDisappear"
            id="sport1_coin1"
            class="top-[281px] right-[178px] w-14 h-[54px] absolute z-[10] coin1_animation"
            :src="
              handleImportImage(themeName, `virtualPage/coin${imgName}1.png`)
            "
            alt=""
          />
          <img
            v-if="!isDisappear"
            id="sport1_coin2"
            class="top-[52px] right-[272px] w-[39px] h-[30px] absolute z-[10] coin2_animation"
            :src="
              handleImportImage(themeName, `virtualPage/coin${imgName}2.png`)
            "
            alt=""
          />
          <img
            v-if="!isDisappear"
            id="sport1_pyramid"
            class="w-[121px] top-[213px] left-[-27px] absolute z-[10] h-[81px] pyramid_animation"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/desktop/images/virtualPage/pyramidvirtualbasketball.png'
              )
            "
            alt=""
          />
        </div>
      </div>
      <div class="w-[500px] h-[650px] relative sport_company_logo">
        <div class="h-[330px]">
          <transition appear mode="out-in">
            <div v-if="!isDisappear" class="relative w-full">
              <div class="sport_info">
                <div>
                  <div v-if="activeTab !== 'virtualsports'">
                    <img
                      class="w-500 h-[148px]"
                      :src="
                        handleImportImage(
                          themeName,
                          `${folderName}/font${imgName}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div v-if="activeTab === 'virtualsports'">
                    <img
                      class="w-500 h-[148px]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/desktop/images/virtualPage/fontsbo.png'
                        )
                      "
                      alt="logo"
                    />
                  </div>
                </div>
                <div class="my-[20px] text-[16px] font-medium">
                  <span v-if="!$t(gameEntrySelected[currentIndex].IntroForDisplay.short).includes('_')">{{
                    $t(gameEntrySelected[currentIndex].IntroForDisplay.short)
                  }}</span>
                </div>
                <div v-if="gameEntrySelected.length > 1" class="flex w-full">
                  <img
                    class="max-h-[40px]"
                    :src="
                      getAssetImage(
                        'assets/theme/light_flexible_1/desktop/images/sportPage/sportlist.png'
                      )
                    "
                    alt=""
                  />
                </div>
              </div>
            </div>
          </transition>
          <div
            v-if="tabSelected === 'cockfight'"
            class="w-full h-[100px] flex justify-start items-start cursor-pointer"
          >
            <nuxt-link
              :to="
                authenticated
                  ? `/Game/${selectedSport?.GameId}${tabTypeForRoute}`
                  : '/login'
              "
              class="flex items-center justify-center text-lg sport-entry-play-button"
            >
              {{ $t("play_now") }}
            </nuxt-link>
          </div>
        </div>
        <div
          v-if="gameEntrySelected.length > 1"
          class="w-full py-4 max-h-64 sport swiper game-banner-swiper swiper-initialized swiper-horizontal swiper-pointer-events swiper-backface-hidden"
        >
          <div class="relative">
            <section class="">
              <swiper
                :slides-per-view="5"
                :modules="modules"
                :navigation="gameEntrySelected.length > 6"
                class="swiper-wrapper sport-swiper"
              >
                <template
                  v-for="(game, index) in gameEntrySelected"
                  :key="game"
                  class="filter-item"
                >
                  <swiper-slide
                    v-if="game !== undefined"
                    class="flex flex-col items-center w-4/12 swiper-slide"
                  >
                    <div
                      class="cursor-pointer group"
                      :class="
                        changeName(game.EnglishGameName) === imgName
                          ? 'sport_tab_active'
                          : 'sport_tab'
                      "
                      @click="toggleTab(game, index)"
                    >
                      <div v-if="virtualSport">
                        <img
                          class="w-[32px] h-[32px] img-inactive"
                          :class="
                            changeName(game.EnglishGameName) !== imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            handleImportImage(
                              themeName,
                              `productHover/${handleRemoveSpaceSpecialCharFormatted(
                                game.EnglishGameName
                              )}${
                                handleRemoveSpaceSpecialCharFormatted(
                                  game.EnglishGameName
                                ) !== 'sbolive'
                                  ? 'logo'
                                  : 'casinologo'
                              }.png`
                            )
                          "
                          alt="logo"
                        />
                        <img
                          class="w-[32px] h-[32px] img-active"
                          :class="
                            changeName(game.EnglishGameName) === imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            handleImportImage(
                              themeName,
                              `productHover/activeIco/${handleRemoveSpaceSpecialCharFormatted(
                                game.EnglishGameName
                              )}${
                                handleRemoveSpaceSpecialCharFormatted(
                                  game.EnglishGameName
                                ) !== 'sbolive'
                                  ? 'logo'
                                  : 'casinologo'
                              }.png`
                            )
                          "
                          alt="logo"
                        />
                      </div>
                      <div v-if="!virtualSport">
                        <img
                          class="w-[32px] h-[32px] block img-inactive"
                          :class="
                            changeName(game.EnglishGameName) !== imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/productHover/sbologo.png'
                            )
                          "
                          alt="logo"
                        />
                        <img
                          class="w-[32px] h-[32px] img-active"
                          :class="
                            changeName(game.EnglishGameName) === imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/productHover/activeIco/sbologo.png'
                            )
                          "
                          alt="logo"
                        />
                      </div>
                    </div>
                    <div
                      class="py-3 text-center text-[14px] font-medium w-[76px] break-words"
                    >
                      <span>{{ game?.GameNameForDisplay }}</span>
                    </div>
                  </swiper-slide>
                </template>
              </swiper>
            </section>
          </div>
        </div>
        <div
          v-if="tabSelected !== 'cockfight'"
          class="w-full h-[100px] flex justify-start items-start mt-[47px] cursor-pointer"
        >
          <div
            v-if="selectedSport?.GameId !== 73"
            class="flex items-center justify-center text-lg sport-entry-play-button"
            @click="onPlay(selectedSport)"
          >
            {{ $t("play_now") }}
          </div>
          <div v-else>
            <div
              v-if="authenticated"
              class="flex items-center justify-center text-lg sport-entry-play-button"
              @click="
                handleGameEntryOpenWindow(
                  selectedSport,
                  375,
                  667,
                  EnumEntranceLocation.GameLobby
                )
              "
            >
              {{ $t("play_now") }}
            </div>
            <nuxt-link
              v-else
              :to="'/login'"
              class="flex items-center justify-center text-lg sport-entry-play-button"
            >
              {{ $t("play_now") }}
            </nuxt-link>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, ref } from "vue";
import { useRoute } from "vue-router";
import { Navigation } from "swiper";
import {
  useGameEntryBaseOnTabSelected,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import EnumProviderIntro from '~~/models/enums/enumProviderIntro';
import { IGame } from "@/models/IGetPlayableGamesResponse";

export default defineComponent({
  props: {
    activeTab: {
      type: String,
      require: true,
    },
  },
  setup(props) {
    const router = useRouter();
    const { gameEntrySelected } = useGameEntryBaseOnTabSelected();

    const { getAssetImage, handleRemoveSpaceSpecialCharFormatted } =
      commonHelper;
    const themeName = "light_flexible_1";
    const changeName = (name: string) => {
      let nameLower = handleRemoveSpaceSpecialCharFormatted(name);
      if (nameLower === "sport") nameLower = "manaulsport";
      return nameLower !== "sbolive" ? nameLower : `${nameLower}video`;
    };
    const authenticated = computed(() => store.state.auth);
    const selectedSport = ref<IGameBsi>(gameEntrySelected.value[0]);
    const isDisappear = ref(false);
    const imgName = ref(
      gameEntrySelected.value[0] !== undefined
        ? changeName(gameEntrySelected.value[0].EnglishGameName)
        : ""
    );
    const currentIndex = ref(0);
    const toggleTab = (sport: IGameBsi, currIndex: number) => {
      currentIndex.value = currIndex;
      isDisappear.value = !isDisappear.value;
      selectedSport.value = sport;
      imgName.value = changeName(sport.EnglishGameName);
      setTimeout(() => {
        isDisappear.value = !isDisappear.value;
      }, 1000);
    };
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const route = useRoute();
    const array: Array<string> = ["virtualsports"];
    const tabSelected = computed(() =>
      _.replace(
        _.replace(route.path.split("/")[1], "-", ""),
        "/",
        ""
      ).toLowerCase()
    );
    const virtualSport = computed(() => !_.includes(array, tabSelected.value));
    const folderName = ref("");
    const bannerImg = ref("");
    function checkFolderName() {
      if (props.activeTab === "sports") {
        folderName.value = "sportPage";
        bannerImg.value = "sport";
      }
      if (props.activeTab === "virtualsports") {
        folderName.value = "virtualPage";
        bannerImg.value = "virtual";
      }
      if (props.activeTab === "cockfight") {
        folderName.value = "cockfight";
      }
    }
    checkFolderName();
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        if (item !== undefined) {
          const tabType = item.TabType.replaceAll(" ", "-").toLowerCase();
          result = tabType === "cock-fight" ? "cockfight" : tabType;
        }
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const onPlay = (game: IGame) => {
      if (authenticated.value) {
        if (game.GameId === 74) handleGameEntryOpenWindow(game, 1200, 850, EnumEntranceLocation.GameLobby);
        else {
          router.push(`/Game/${game.GameId}${tabTypeForRoute.value}`);
          window.scrollTo({ top: 0, behavior: "smooth" });
        }
      } else {
        router.push("/login");
      }
    };
    const activeBtnBackground = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background-active.png"
    )})`;

    return {
      toggleTab,
      isDisappear,
      gameEntrySelected,
      isGameLoading,
      imgName,
      handleRemoveSpaceSpecialCharFormatted,
      virtualSport,
      changeName,
      selectedSport,
      authenticated,
      tabSelected,
      folderName,
      bannerImg,
      EnumEntranceLocation,
      tabTypeForRoute,
      handleImportImage: commonHelper.handleImportImage,
      themeName,
      handleGameEntryOpenWindow,
      onPlay,
      getAssetImage,
      activeBtnBackground,
      modules: [Navigation],
      currentIndex,
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(.swiper-slide, swiper-slide) {
  display: flex;
}
:deep(.sport-swiper .swiper-button-next) {
  translate: 8px -30px;
}
:deep(.sport-swiper .swiper-button-prev) {
  translate: -8px -30px;
}
:deep(.swiper-button-prev:after) {
  font-size: 15px;
}
:deep(.swiper-button-next:after) {
  font-size: 15px;
}
.sport-entry-play-button {
  background-image: var(--activeBtnBackground);
  background-size: contain;
  min-width: 160px;
  width: fit-content;
  height: 50px;
  color: white;
  cursor: pointer;
  transition: 0.3s ease-in-out;
  border-radius: 30px;
  padding: 0 10px;
}
.swiper {
  padding-top: 10px;
}
.sport-ads-animation .v-enter-active,
.sport-ads-animation .v-leave-active {
  transition: all 1s ease;
}

.sport-ads-animation .v-leave-from,
.sport-ads-animation .v-enter-to {
  opacity: 1;
  transform: scale(1, 1);
}

.sport-ads-animation .v-enter-from,
.sport-ads-animation .v-leave-to {
  opacity: 0;
  transform: scale(1, 0.9);
}
.sport_company_logo .v-enter-active,
.sport_company_logo .v-leave-active {
  transition: all 1s ease;
}
.sport_company_logo .v-leave-from {
  opacity: 1;
}
.sport_company_logo .v-leave-to {
  opacity: 0;
}
.sport_company_logo .v-enter-to {
  opacity: 1;
  margin-left: 0;
}

.sport_company_logo .v-enter-from {
  opacity: 0;
  margin-left: 50px;
}
.page-banner-logo .v-enter-active,
.page-banner-logo .v-leave-active {
  transition: all 1s ease;
}

.page-banner-logo .v-leave-from,
.page-banner-logo .v-enter-to {
  opacity: 1;
  top: 0;
}

.page-banner-logo .v-enter-from,
.page-banner-logo .v-leave-to {
  opacity: 0;
  top: -50px;
}
#pageBannerImg {
  position: absolute;
  display: block;
  width: 520px;
  height: 300px;
  margin-left: auto;
  margin-right: auto;
  cursor: inherit;
  z-index: 1;
}
.sport_ads {
  position: absolute;
  z-index: 2;
  top: 0;
  left: -65px;
  display: block;
}
</style>
